"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageDialogContentInner = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../../Button");
const Heading_1 = require("../../Heading");
const Layout_1 = require("../../Layout");
const SectioningContent_1 = require("../../SectioningContent");
const Text_1 = require("../../Text");
const dialogHelper_1 = require("../dialogHelper");
const CLOSE_BUTTON_LABEL = '閉じる';
const messegeDialogContentInner = (0, tailwind_variants_1.tv)({
    slots: {
        titleArea: 'smarthr-ui-Dialog-titleArea shr-border-b-shorthand shr-my-[unset] shr-px-1.5 shr-py-1',
        footer: 'smarthr-ui-Dialog-buttonArea shr-border-t-shorthand shr-flex shr-justify-end shr-px-1.5 shr-py-1',
    },
});
// FIXME: 他のダイアログと共通化したかったが別でやる
const dialogBody = (0, tailwind_variants_1.tv)({
    base: ['smarthr-ui-Dialog-description', 'shr-overflow-auto shr-text-base'],
    variants: {
        contentPaddingBlock: {
            0: 'shr-py-0',
            0.25: 'shr-py-0.25',
            0.5: 'shr-py-0.5',
            0.75: 'shr-py-0.75',
            1: 'shr-py-1',
            1.25: 'shr-py-1.25',
            1.5: 'shr-py-1.5',
            2: 'shr-py-2',
            2.5: 'shr-py-2.5',
            3: 'shr-py-3',
            3.5: 'shr-py-3.5',
            4: 'shr-py-4',
            8: 'shr-py-8',
            X3S: 'shr-py-0.25',
            XXS: 'shr-py-0.5',
            XS: 'shr-py-1',
            S: 'shr-py-1.5',
            M: 'shr-py-2',
            L: 'shr-py-2.5',
            XL: 'shr-py-3',
            XXL: 'shr-py-3.5',
            X3L: 'shr-py-4',
        },
        contentPaddingInline: {
            0: 'shr-px-0',
            0.25: 'shr-px-0.25',
            0.5: 'shr-px-0.5',
            0.75: 'shr-px-0.75',
            1: 'shr-px-1',
            1.25: 'shr-px-1.25',
            1.5: 'shr-px-1.5',
            2: 'shr-px-2',
            2.5: 'shr-px-2.5',
            3: 'shr-px-3',
            3.5: 'shr-px-3.5',
            4: 'shr-px-4',
            8: 'shr-px-8',
            X3S: 'shr-px-0.25',
            XXS: 'shr-px-0.5',
            XS: 'shr-px-1',
            S: 'shr-px-1.5',
            M: 'shr-px-2',
            L: 'shr-px-2.5',
            XL: 'shr-px-3',
            XXL: 'shr-px-3.5',
            X3L: 'shr-px-4',
        },
        contentBgColor: {
            BACKGROUND: 'shr-bg-background',
            COLUMN: 'shr-bg-column',
            BASE_GREY: 'shr-bg-base-grey',
            OVER_BACKGROUND: 'shr-bg-over-background',
            HEAD: 'shr-bg-head',
            BORDER: 'shr-bg-[theme(colors.grey.20)]',
            ACTION_BACKGROUND: 'shr-bg-action-background',
            WHITE: 'shr-bg-white',
            GREY_5: 'shr-bg-[theme(colors.grey.5)]',
            GREY_6: 'shr-bg-[theme(colors.grey.6)]',
            GREY_7: 'shr-bg-[theme(colors.grey.7)]',
            GREY_9: 'shr-bg-[theme(colors.grey.9)]',
            GREY_20: 'shr-bg-[theme(colors.grey.20)]',
            GREY_30: 'shr-bg-[theme(colors.grey.30)]',
            GREY_65: 'shr-bg-[theme(colors.grey.65)]',
            GREY_100: 'shr-bg-[theme(colors.grey.100)]',
        },
    },
});
const MessageDialogContentInner = ({ title, subtitle, titleTag, titleId, contentBgColor, contentPadding = 1.5, description, onClickClose, decorators, }) => {
    const { offsetHeight, titleRef, bottomRef } = (0, dialogHelper_1.useOffsetHeight)();
    const { titleAreaStyle, bodyStyleProps, footerStyle } = (0, react_1.useMemo)(() => {
        const { titleArea, footer } = messegeDialogContentInner();
        const paddingBlock = contentPadding instanceof Object ? contentPadding.block : contentPadding;
        const paddingInline = contentPadding instanceof Object ? contentPadding.inline : contentPadding;
        return {
            titleAreaStyle: titleArea(),
            bodyStyleProps: {
                style: {
                    maxHeight: `calc(100svh - ${offsetHeight}px)`,
                },
                className: dialogBody({
                    contentBgColor,
                    contentPaddingBlock: paddingBlock,
                    contentPaddingInline: paddingInline,
                }),
            },
            footerStyle: footer(),
        };
    }, [contentBgColor, contentPadding, offsetHeight]);
    return (react_1.default.createElement(SectioningContent_1.Section, null,
        react_1.default.createElement(Heading_1.Heading, { tag: titleTag },
            react_1.default.createElement(Layout_1.Stack, { gap: 0.25, as: "span", ref: titleRef, className: titleAreaStyle },
                subtitle && (react_1.default.createElement(Text_1.Text, { size: "S", color: "TEXT_GREY", className: "smarthr-ui-Dialog-subtitle" }, subtitle)),
                react_1.default.createElement(Text_1.Text, { id: titleId, size: "L", className: "smarthr-ui-Dialog-title" }, title))),
        react_1.default.createElement("div", { ...bodyStyleProps }, description),
        react_1.default.createElement("footer", { ref: bottomRef, className: footerStyle },
            react_1.default.createElement(Button_1.Button, { onClick: onClickClose, className: "smarthr-ui-Dialog-closeButton" }, decorators?.closeButtonLabel?.(CLOSE_BUTTON_LABEL) || CLOSE_BUTTON_LABEL))));
};
exports.MessageDialogContentInner = MessageDialogContentInner;
//# sourceMappingURL=MessageDialogContentInner.js.map