"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SearchInput = void 0;
const react_1 = __importStar(require("react"));
const tailwind_variants_1 = require("tailwind-variants");
const Button_1 = require("../../Button");
const Icon_1 = require("../../Icon");
const VisuallyHiddenText_1 = require("../../VisuallyHiddenText");
const InputWithTooltip_1 = require("../InputWithTooltip");
const ICON_ALT = '検索';
const CLEAR_BUTTON_ALT = '削除';
const searchInput = (0, tailwind_variants_1.tv)({
    slots: {
        clearButton: [
            'smarthr-ui-SearchInput-clearButton',
            'shr-group/clearButton',
            'shr-cursor-pointer',
            'focus-visible:shr-shadow-none',
        ],
        clearButtonIcon: [
            'shr-block',
            'group-focus-visible/clearButton:shr-focus-indicator group-focus-visible/clearButton:shr-rounded-full',
        ],
    },
});
exports.SearchInput = (0, react_1.forwardRef)(({ decorators, onClickClear, ...props }, ref) => {
    const { clearButton, clearButtonIcon } = searchInput();
    const { clearButtonStyle, clearButtonIconStyle } = (0, react_1.useMemo)(() => ({
        clearButtonStyle: clearButton(),
        clearButtonIconStyle: clearButtonIcon(),
    }), [clearButton, clearButtonIcon]);
    const iconAlt = (0, react_1.useMemo)(() => decorators?.iconAlt?.(ICON_ALT) || ICON_ALT, [decorators]);
    const clearButtonAlt = (0, react_1.useMemo)(() => decorators?.clearButtonAlt?.(CLEAR_BUTTON_ALT) || CLEAR_BUTTON_ALT, [decorators]);
    const defaultInptuId = (0, react_1.useId)();
    const inputId = props.id || defaultInptuId;
    return (react_1.default.createElement("span", null,
        react_1.default.createElement("label", { htmlFor: inputId },
            react_1.default.createElement(VisuallyHiddenText_1.VisuallyHiddenText, null, iconAlt)),
        react_1.default.createElement(InputWithTooltip_1.InputWithTooltip, { ...props, id: inputId, ref: ref, prefix: react_1.default.createElement(Icon_1.FaMagnifyingGlassIcon, { color: "TEXT_GREY" }), suffix: onClickClear &&
                props.value && (react_1.default.createElement(Button_1.UnstyledButton, { onClick: (e) => onClickClear(e), className: clearButtonStyle },
                react_1.default.createElement(Icon_1.FaCircleXmarkIcon, { color: "TEXT_BLACK", alt: clearButtonAlt, className: clearButtonIconStyle }))) })));
});
//# sourceMappingURL=SearchInput.js.map